/* global properties, sjcl, context */

// coerce the properties to strings
var message = properties.message + '',
    key = properties.key +'';

context.setVariable("hmac.message", message);
context.setVariable("hmac.key", key);

function computeHmacsAndSetVariables(key, message, flavor) {
  var hmac = new sjcl.misc.hmac(sjcl.codec.utf8String.toBits(key), sjcl.hash[flavor]);
  var encrypted = hmac.encrypt(message);
  ['base64', 'hex'].forEach( function(encoding) {
    var varname = 'hmac.' + flavor + '-' + encoding;
    var signature = sjcl.codec[encoding].fromBits(encrypted);
    context.setVariable(varname, signature);
  });
}

['sha1', 'sha256'].forEach(function(sha) {
  computeHmacsAndSetVariables(key, message, sha);
});
