/* global properties, context, OAuth */

var options = {
      version          : properties.version || '1.0A',
      signature_method : 'HMAC-SHA1',
      method           : properties.method,
      url              : properties.url,
      consumerkey      : properties.consumerkey,
      consumersecret   : properties.consumersecret,
      paramString      : properties.params,
      nonce            : properties.nonce,
      timestamp        : properties.timestamp
    },
    oauth = new OAuth(options),
    normalized = oauth.computeNormalizedParameters(),
    baseString = oauth.computeBaseString(normalized),
    signature = oauth.computeSignature(baseString),
    header = oauth.produceAuthzHeader(signature);

context.setVariable("oauthv10a.normalized", normalized);
context.setVariable("oauthv10a.base_string", baseString);
context.setVariable("oauthv10a.signature", signature);
context.setVariable("oauthv10a.authzheader", header);
